"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _utils = require("../../utils");

var _SelectWidget = require("./../widgets/SelectWidget");

var _SelectWidget2 = _interopRequireDefault(_SelectWidget);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ArrayField = function (_Component) {
  _inherits(ArrayField, _Component);

  function ArrayField(props) {
    _classCallCheck(this, ArrayField);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ArrayField).call(this, props));

    _this.onAddClick = function (event) {
      event.preventDefault();
      var items = _this.state.items;
      var _this$props = _this.props;
      var schema = _this$props.schema;
      var registry = _this$props.registry;
      var definitions = registry.definitions;

      _this.asyncSetState({
        items: items.concat([(0, _utils.getDefaultFormState)(schema.items, undefined, definitions)])
      }, { validate: false });
    };

    _this.onDropIndexClick = function (index) {
      return function (event) {
        event.preventDefault();
        _this.asyncSetState({
          items: _this.state.items.filter(function (_, i) {
            return i !== index;
          })
        }, { validate: false });
      };
    };

    _this.onChangeForIndex = function (index) {
      return function (value) {
        _this.asyncSetState({
          items: _this.state.items.map(function (item, i) {
            return index === i ? value : item;
          })
        }, { validate: false });
      };
    };

    _this.onSelectChange = function (value) {
      _this.asyncSetState({ items: value }, { validate: false });
    };

    _this.state = _this.getStateFromProps(props);
    return _this;
  }

  _createClass(ArrayField, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState(this.getStateFromProps(nextProps));
    }
  }, {
    key: "getStateFromProps",
    value: function getStateFromProps(props) {
      var formData = Array.isArray(props.formData) ? props.formData : null;
      var definitions = this.props.registry.definitions;

      return {
        items: (0, _utils.getDefaultFormState)(props.schema, formData, definitions) || []
      };
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _utils.shouldRender)(this, nextProps, nextState);
    }
  }, {
    key: "isItemRequired",
    value: function isItemRequired(itemsSchema) {
      return itemsSchema.type === "string" && itemsSchema.minLength > 0;
    }
  }, {
    key: "asyncSetState",
    value: function asyncSetState(state, options) {
      var _this2 = this;

      // ensure state is propagated to parent component when it's actually set
      this.setState(state, function (_) {
        return _this2.props.onChange(_this2.state.items, options);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _props = this.props;
      var schema = _props.schema;
      var uiSchema = _props.uiSchema;
      var errorSchema = _props.errorSchema;
      var idSchema = _props.idSchema;
      var name = _props.name;

      var title = schema.title || name;
      var items = this.state.items;
      var _props$registry = this.props.registry;
      var fields = _props$registry.fields;
      var definitions = _props$registry.definitions;
      var SchemaField = fields.SchemaField;

      var itemsSchema = (0, _utils.retrieveSchema)(schema.items, definitions);
      if ((0, _utils.isMultiSelect)(schema)) {
        return _react2.default.createElement(_SelectWidget2.default, {
          id: idSchema && idSchema.id,
          multiple: true,
          onChange: this.onSelectChange,
          options: (0, _utils.optionsList)(itemsSchema),
          schema: schema,
          title: title,
          defaultValue: schema.default,
          value: items
        });
      }

      return _react2.default.createElement(
        "fieldset",
        {
          className: "field field-array field-array-of-" + itemsSchema.type },
        title ? _react2.default.createElement(
          "legend",
          null,
          title
        ) : null,
        schema.description ? _react2.default.createElement(
          "div",
          { className: "field-description" },
          schema.description
        ) : null,
        _react2.default.createElement(
          "div",
          { className: "row array-item-list" },
          items.map(function (item, index) {
            var itemErrorSchema = errorSchema ? errorSchema[index] : undefined;
            var itemIdPrefix = idSchema.id + "_" + index;
            var itemIdSchema = (0, _utils.toIdSchema)(itemsSchema, itemIdPrefix, definitions);
            return _react2.default.createElement(
              "div",
              { key: index },
              _react2.default.createElement(
                "div",
                { className: "col-xs-10" },
                _react2.default.createElement(SchemaField, {
                  schema: itemsSchema,
                  uiSchema: uiSchema.items,
                  formData: items[index],
                  errorSchema: itemErrorSchema,
                  idSchema: itemIdSchema,
                  required: _this3.isItemRequired(itemsSchema),
                  onChange: _this3.onChangeForIndex(index),
                  registry: _this3.props.registry })
              ),
              _react2.default.createElement(
                "div",
                { className: "col-xs-2 array-item-remove text-right" },
                _react2.default.createElement(
                  "button",
                  { type: "button", className: "btn btn-danger col-xs-12",
                    tabIndex: "-1",
                    onClick: _this3.onDropIndexClick(index) },
                  "Delete"
                )
              )
            );
          })
        ),
        _react2.default.createElement(
          "div",
          { className: "row" },
          _react2.default.createElement(
            "p",
            { className: "col-xs-2 col-xs-offset-10 array-item-add text-right" },
            _react2.default.createElement(
              "button",
              { type: "button", className: "btn btn-info col-xs-12",
                tabIndex: "-1", onClick: this.onAddClick },
              "Add"
            )
          )
        )
      );
    }
  }, {
    key: "itemTitle",
    get: function get() {
      var schema = this.props.schema;

      return schema.items.title || schema.items.description || "Item";
    }
  }]);

  return ArrayField;
}(_react.Component);

ArrayField.defaultProps = {
  uiSchema: {},
  idSchema: {}
};


if (process.env.NODE_ENV !== "production") {
  ArrayField.propTypes = {
    schema: _react.PropTypes.object.isRequired,
    uiSchema: _react.PropTypes.object,
    idSchema: _react.PropTypes.object,
    errorSchema: _react.PropTypes.object,
    onChange: _react.PropTypes.func.isRequired,
    formData: _react.PropTypes.array,
    registry: _react.PropTypes.shape({
      widgets: _react.PropTypes.objectOf(_react.PropTypes.func).isRequired,
      fields: _react.PropTypes.objectOf(_react.PropTypes.func).isRequired
    })
  };
}

exports.default = ArrayField;