"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function URLWidget(_ref) {
  var schema = _ref.schema;
  var id = _ref.id;
  var placeholder = _ref.placeholder;
  var value = _ref.value;
  var defaultValue = _ref.defaultValue;
  var required = _ref.required;
  var _onChange = _ref.onChange;

  return _react2.default.createElement("input", { type: "url",
    id: id,
    className: "form-control",
    value: value,
    defaultValue: defaultValue,
    placeholder: placeholder,
    required: required,
    onChange: function onChange(event) {
      return _onChange(event.target.value);
    } });
}

if (process.env.NODE_ENV !== "production") {
  URLWidget.propTypes = {
    schema: _react.PropTypes.object.isRequired,
    id: _react.PropTypes.string.isRequired,
    placeholder: _react.PropTypes.string,
    value: _react2.default.PropTypes.string,
    defaultValue: _react2.default.PropTypes.string,
    required: _react.PropTypes.bool,
    onChange: _react.PropTypes.func
  };
}

exports.default = URLWidget;