"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function rangeSpec(schema) {
  var spec = {};
  if (schema.multipleOf) {
    spec.step = schema.multipleOf;
  }
  if (schema.minimum) {
    spec.min = schema.minimum;
  }
  if (schema.maximum) {
    spec.max = schema.maximum;
  }
  return spec;
}

function UpDownWidget(_ref) {
  var schema = _ref.schema;
  var id = _ref.id;
  var placeholder = _ref.placeholder;
  var value = _ref.value;
  var defaultValue = _ref.defaultValue;
  var required = _ref.required;
  var _onChange = _ref.onChange;

  return _react2.default.createElement("input", _extends({ type: "number",
    id: id,
    className: "form-control",
    value: value,
    defaultValue: defaultValue,
    placeholder: placeholder,
    required: required,
    onChange: function onChange(event) {
      return _onChange(event.target.value);
    }
  }, rangeSpec(schema)));
}

if (process.env.NODE_ENV !== "production") {
  UpDownWidget.propTypes = {
    schema: _react.PropTypes.object.isRequired,
    id: _react.PropTypes.string.isRequired,
    placeholder: _react.PropTypes.string,
    value: _react.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number]),
    defaultValue: _react.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number]),
    required: _react.PropTypes.bool,
    onChange: _react.PropTypes.func
  };
}

exports.default = UpDownWidget;